#!/usr/bin/X11/tixwish
#  File: cal.tcl
# 
#      This file is part of minkowsky
# 
#      Copyright (C) 2001-2002 by Rdiger Goetz
#      Author: Rdiger Goetz <minkowsky@r-goetz.de>
# 
#      Time-stamp: <19-Sep-2002 21:50:43 goetz>
# 
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
# 
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
# 
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#  

proc displayYearCalAtPosition { day mon year x y win} {
    global callerRequest sDay sMon sYear
    set cwin ".cov-setDate"


    set sDay($cwin) $day
    set sMon($cwin) $mon
    set sYear($cwin) $year


    if {[winfo exists $win]} {destroy $cwin}
    
    set callerRequest "getDate"
    _displayYearCal $cwin $day $mon $year
    wm geometry $cwin 226x290+$x+$y
    wm transient $cwin $win
#    grab $cwin
    update 
    tkwait window $cwin
    return "$sDay($cwin) $sMon($cwin) $sYear($cwin)"
}
proc displayYearCal { day mon year} {
    global callerRequest
    set cwin ".cov-jump"
    set callerRequest "jump"
    _displayYearCal $cwin $day $mon $year
    update
}
proc _displayYearCal {cwin  day mon year} {
    global fnt bfnt10 bfnt fnt10 monLen
    global covDay covMon covYear covWin
    global weekDaysAbk   covDHwin covDin
    global covStartDay covStartMon covStartYear
    global tyear tmon tday        covTodatDwin
    global _calText _buttonText monAbk
    global callerRequest

    if { [winfo exists $cwin] == 1 } { return }
    toplevel $cwin 
    wm geometry $cwin 226x290

    set covDay($cwin) $day
    set covMon($cwin) $mon
    set covYear($cwin) $year
    set covStartDay($cwin)  $covDay($cwin)
    set covStartMon($cwin)  $covMon($cwin)
    set covStartYear($cwin) $covYear($cwin)
    set covDHwin ""
    
    set off 3

    frame $cwin.y -relief raised -bd 1
    frame $cwin.m -relief raised -bd 1
    frame $cwin.c -relief raised -bd 1
    frame $cwin.b -relief flat
    pack $cwin.y $cwin.m $cwin.c $cwin.b  -side top -fill x -pady 1

    button $cwin.y.l -text "<<" -bd 1 -command COVlastYear
    bind   $cwin.y.l <Button> {set covWin %W}
    frame $cwin.y.y 
    button $cwin.y.r -text ">>" -bd 1 -command COVnextYear
    bind   $cwin.y.r <Button> {set covWin %W}
    pack $cwin.y.l -side left -fill x 
    pack $cwin.y.y -side left -fill x -expand 1
    pack $cwin.y.r -side right -fill x 
    
    label $cwin.y.y.l -text $year -anchor n -font $bfnt
    pack  $cwin.y.y.l -side top -fill x

    frame $cwin.m.1 
    frame $cwin.m.2
    pack $cwin.m.1  $cwin.m.2 -side top -fill x
    for { set i 1} { $i<=6} {incr i} {
	button $cwin.m.1.$i -text [lindex $monAbk $i] -bd 1 -font $bfnt10 -width 1 -command {COVswitchMon}
	pack $cwin.m.1.$i -side left -fill x -expand 1
	bind $cwin.m.1.$i <Button> {set covWin %W}
    }
    for { set i 7} { $i<=12} {incr i} {
	button $cwin.m.2.$i -text [lindex $monAbk $i] -bd 1 -font $bfnt10 -width 1 -command {COVswitchMon}
	pack $cwin.m.2.$i -side left -fill x -expand 1
	bind $cwin.m.2.$i <Button> {set covWin %W}
    }
    puts "MON=$mon"
    if { $mon < 7 } {
	$cwin.m.1.$mon configure -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    } else {
	$cwin.m.2.$mon configure -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    }

    frame  $cwin.c.d
    pack $cwin.c.d -side top -fill x
    for {set d 1} {$d<=7} {incr d} {
 	label $cwin.c.d.$d -text [lindex $weekDaysAbk [expr $d -1 ]] -relief raised -bd 1  -width 2 -font $bfnt10 -anchor n
 	pack $cwin.c.d.$d -side left -fill x -expand 1  -padx 1
    }
    for {set w 0} {$w<=5} {incr w} {
	frame  $cwin.c.$w 
	pack $cwin.c.$w  -side top -fill x
	for {set d 1} {$d<=7} {incr d} {
	    button $cwin.c.$w.$d -text "" -width 1 -font $fnt10 -command jump2CalDate
	    pack $cwin.c.$w.$d  -side left
	    bind $cwin.c.$w.$d <Button> {set covDwin %W}
	}
    }
    fillMonInCalView 0 $cwin

    wm title $cwin $_calText(NaviTitle)
    button $cwin.b.today -text $_calText(Heute) -command {
	set cwin ".[lindex [split $covWin .] 1]"
	set covDay($cwin)  $tday
	set covMon($cwin)  $tmon
	set covYear($cwin) $tyear
	COVTodaysYear
    }	
    bind   $cwin.b.today <Button> {set covWin %W}

    button $cwin.b.cancel -text $_buttonText(Cancel) -command {
	set cwin ".[lindex [split $covWin .] 1]"
	set covDay($cwin)  $covStartDay($cwin)
	set covMon($cwin)  $covStartMon($cwin)
	set covYear($cwin) $covStartYear($cwin)
	set sDay($cwin)  $covDay($cwin)
	set sMon($cwin)  $covMon($cwin)
	set sYear($cwin) $covYear($cwin)
	announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
	destroy $cwin
    }
    bind   $cwin.b.cancel <Button> {set covWin %W}

    button $cwin.b.close -text $_buttonText(Close) -command {
	set cwin ".[lindex [split $covWin .] 1]"
	destroy $cwin
    }
    bind   $cwin.b.close <Button> {set covWin %W}
    pack $cwin.b.today $cwin.b.cancel -side left  -padx 1 -pady 1
    pack $cwin.b.close -side right -padx 1 -pady 1
}
proc fillMonInCalView { upd cwin} {
    global monlen
    global fnt fnt10 bfnt10  covDHwin covWDList
    global covMon covDay covYear
    global holidays holidayNames holidayMonth
    global tday tmon tyear covTodatDwin

    if { $covDHwin != "" } {   
	$covDHwin configure  -bg lightgray -activebackground lightgray
    }
    set off [weekDayByDate 1 $covMon($cwin) $covYear($cwin)]

    set moff 0
    if { $covMon($cwin)  == 2 } {
	if {[ expr $covYear($cwin) % 4] == 0 } { set moff 1} 
    } 
    set ml [expr [lindex $monlen $covMon($cwin)] + $moff]
    if { $covDay($cwin) > $ml } { set covDay($cwin) $ml}

    set mtag [format "%04d-%02d" $covYear($cwin) $covMon($cwin)]
    if { [lsearch $holidayMonth $mtag] >=0 } {
	set hlist $holidays($mtag)
    } else {
	set hlist ""
    }

    for {set w 0} {$w<=5} {incr w} {
	for {set d 1} {$d<=7} {incr d} {
	    set wd [expr $w*7+$d -$off]
	    if { $wd <=0  || $wd > $ml} {
		$cwin.c.$w.$d configure -text ""  -width 1 -font $fnt10 -relief flat -state disabled 
	    } else {
		$cwin.c.$w.$d configure  -text $wd -width 1 -font $fnt10 -relief raised -state normal
	    }
		
	    if { $covDay($cwin) == $wd} {
		$cwin.c.$w.$d configure -bg wheat -activebackground wheat
		set covDHwin $cwin.c.$w.$d
	    }
	    #Holidays
	    if { $d >5} {
		$cwin.c.$w.$d configure -fg red4 -activeforeground red4 
	    } elseif { [lsearch $hlist $wd] >=0} {
		$cwin.c.$w.$d configure -fg red4 -activeforeground red4 
	    } else {	    
		$cwin.c.$w.$d configure -fg black -activeforeground  black
	    }
	    if { $covYear($cwin) == $tyear }  {
		if { $covMon($cwin) == $tmon }  {
		    if { $wd == $tday }  {
			$cwin.c.$w.$d configure -font  $bfnt10
			set covTodatDwin $cwin.c.$w.$d
		    }
		}
	    }
	    set covWDList($w-$d) $wd
	}
    }
    if { $upd == 1 } {update  }
}

proc jump2CalDate { } {
    global covWDList covDwin covDay covYear covMon covDHwin
    global sDay sMon sYear 

    set list [split $covDwin .]
    set cwin ".[lindex $list 1]"
    set w [lindex  $list 3]
    set d [lindex  $list 4]
    set covDay($cwin) $covWDList($w-$d)

    $covDHwin configure  -bg lightgray -activebackground lightgray
    $cwin.c.$w.$d configure -bg wheat -activebackground wheat
    set covDHwin $cwin.c.$w.$d

    set sDay($cwin)  $covDay($cwin)
    set sMon($cwin)  $covMon($cwin)
    set sYear($cwin) $covYear($cwin)

#    puts "$sDay $sMon $sYear"
    announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
}
proc  COVswitchMon {} {
    global covWin covMon covDay covYear
    global sDay sMon sYear 

    puts "covWin = $covWin"
    set cwin ".[lindex [split $covWin .] 1]"


    if {$covMon($cwin) <=6} {
	$cwin.m.1.$covMon($cwin) configure  -fg black -bg lightgray -activebackground lightgray -activeforeground black
    } else {
	$cwin.m.2.$covMon($cwin) configure  -fg black -bg lightgray -activebackground lightgray -activeforeground black
    }
    set covMon($cwin) [lindex [split $covWin .] 4]

#    puts " DATE $covDay $covMon $covYear"
    fillMonInCalView 1 $cwin
#    puts ">DATE $covDay $covMon $covYear"

    if {$covMon($cwin) <=6} {
#	puts [$cwin.m.1.$covMon cget -bg]
	update
	$cwin.m.1.$covMon($cwin) configure  -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    } else {
	$cwin.m.2.$covMon($cwin) configure  -fg red4 -bg wheat -activebackground wheat -activeforeground red4
    }
    set sDay($cwin)  $covDay($cwin)
    set sMon($cwin)  $covMon($cwin)
    set sYear($cwin) $covYear($cwin)
    announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
}

proc COVlastYear { } {
    global covMon covDay covYear
    global sDay sMon sYear 
    global covWin

    set cwin ".[lindex [split $covWin .] 1]"

    incr covYear($cwin) -1
    
    $cwin.y.y.l configure -text $covYear($cwin)

    fillMonInCalView 1 $cwin

    set sDay($cwin)  $covDay($cwin)
    set sMon($cwin)  $covMon($cwin)
    set sYear($cwin) $covYear($cwin)
    announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
}
proc COVnextYear { } {
    global covMon covDay covYear
    global sDay sMon sYear 
    global covWin

    set cwin ".[lindex [split $covWin .] 1]"

    incr covYear($cwin) 1
    
    $cwin.y.y.l configure -text $covYear($cwin)
    fillMonInCalView 1 $cwin
    set sDay($cwin)  $covDay($cwin)
    set sMon($cwin)  $covMon($cwin)
    set sYear($cwin) $covYear($cwin)
    announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
}
proc COVTodaysYear { } {
    global covMon covDay covYear
    global sDay sMon sYear  tyear
    global covWin

    set cwin ".[lindex [split $covWin .] 1]"

    set covYear($cwin) $tyear
    
    $cwin.y.y.l configure -text $covYear($cwin)
    fillMonInCalView 1 $cwin
    set sDay($cwin)  $covDay($cwin)
    set sMon($cwin)  $covMon($cwin)
    set sYear($cwin) $covYear($cwin)
    announceDate2Caller $sDay($cwin) $sMon($cwin) $sYear($cwin)
}

proc announceDate2Caller {day mon year } {
#    global sDay sMon sYear
    global callerRequest

#    puts "Caller: $callerRequest"

    if { $callerRequest == "jump" } {
#	puts "JUMP !"
	jump2Date  $day $mon $year
    }     
#    puts "done"
}

